<?php

namespace PurchasingBundle\Repository;


use Psr\Log\LoggerInterface;
use PurchasingBundle\Entity\PurchaseOrder;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;

/**
 * PurchaseOrderRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PurchaseOrderRepository extends SchemaEntityRepository {

    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * PurchaseOrderRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, PurchaseOrder::class);
        $this->logger = $logger;
    }


    /**
     * @return mixed|null
     */
    public function findCountOrders () {

        $qb = $this->getEntityManager()->createQuery(
            'SELECT count(0) AS counted 
                  FROM PurchasingBundle:PurchaseOrder order'
        );

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get count orders", $exception);
        }

        return $result;
    }

}
